/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package JAuto.srv;

public class B3001 extends ioPortT {
	static final int    CHANNELS    = 8;
	static final int    CHANNEL0    = 0;
	static final int    CHANNEL1    = 1;
	static final int    CHANNEL2    = 2;
	static final int    CHANNEL3    = 3;
	static final int    CHANNEL4    = 4;
	static final int    CHANNEL5    = 5;
	static final int    CHANNEL6    = 6;
	static final int    CHANNEL7    = 7;
	
	
	/**
	 * Constructor for B3001.
	 * 
	 * @param name
	 */
	public B3001(String name) {
		super(name);
		setBase(0x03E4);
		setDelay(100);
	}


	/**
	 * Read a channel on the B3001.
	 * 
	 * @param channel		one-based channel index
	 * 
	 * @see ioPortT#read(int)
	 */
	int readChannel(int channel) {
		if (m_isOpen == false) {
			jauto.display("B3001 read: not open");
			return -1;
		}
			
		if (m_base == 0) {
			jauto.display("B3001 read: invalid base addr");
			return -1;
		}
		
		if (channel < 1  ||  channel > CHANNELS) {
			jauto.display("B3001 read: invalid channel");
			return -1;
		}
		
		channel--;		//make channel zero based
		
		int result = ioReadB3001(m_base,channel);
		if (result < 0) {
			jauto.display("B3001 read: _readChannel error");
			result = -1;
		}
		return result;
	}
}
