/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package JAuto.srv;

public class pportT extends ioPortT {
    static final int    CHANNEL0    = 0x01;
    static final int    CHANNEL1    = 0x02;
    static final int    CHANNEL2    = 0x04;
    static final int    CHANNEL3    = 0x08;
    static final int    CHANNEL4    = 0x10;
    static final int    CHANNEL5    = 0x20;
    static final int    CHANNEL6    = 0x40;
    static final int    CHANNEL7    = 0x80;

    byte		m_mask;

	pportT(String name) {
		super(name);
		setBase(0x0378);
		setDelay(100);
	}

	pportT(String name, int base) {
		super(name);
		setBase(base);
		setDelay(100);
	}
	

    void clear() {
        m_mask = 0;
    }

    void reset() {
        clear();
        write(0,m_mask);
    }

	public int setBase(int b) {
        int x= super.setBase(b);
        clear();
        return x;
    }

    byte getMask() {
        return m_mask;
    }

    void setMask(byte m) {
        m_mask = m;
    }

    void setState(int channel, boolean state) {
        if (state==false) 
            off(channel);
        else 
            on(channel);
    }

    private void on(int channel) {
    	if (channel >= 1  &&  channel <= 8) {
    		channel = getChannelId(channel);
            m_mask |= (byte)channel;
            write(0,m_mask);
        }
    }

	private void off(int channel) {
       	if (channel >= 1  &&  channel <= 8) {
       		channel = getChannelId(channel);
            m_mask &= ~((byte)channel);
            write(0,m_mask);
        }
    }

    private int getChannelId(int idx) {
        switch (idx) {
            case 1:     return CHANNEL0;
            case 2:     return CHANNEL1;
            case 3:     return CHANNEL2;
            case 4:     return CHANNEL3;
            case 5:     return CHANNEL4;
            case 6:     return CHANNEL5;
            case 7:     return CHANNEL6;
            case 8:     return CHANNEL7;
        }
        return -1;
    }
}
