/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.srv;

import java.sql.*;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
public class sqlResultT {
    ResultSet           rs;
    ResultSetMetaData   meta;

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public sqlResultT() {
        rs = null;
        meta = null;
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public int getColumnCount()    {
        try { return meta.getColumnCount(); }
        catch (Exception excp) { return 0; }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public String getColumnName(int idx)    {
        try { return meta.getColumnName(idx); }
        catch (Exception excp) { return ""; }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public String getString(int zeroBasedIdx) {
        try {
            return rs.getString(zeroBasedIdx+1); }
        catch (Exception excp) {
            System.out.println("sqlResultT::getString():"+excp);
            return "";
        }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public int getInt(int zeroBasedIdx) {
        try {
            return Integer.parseInt(rs.getString(zeroBasedIdx+1)); }
        catch (Exception excp) {
            System.out.println("sqlResultT::getInt():"+excp);
            return 0;
        }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public long getLong(int zeroBasedIdx) {
        try {
            return Long.parseLong(rs.getString(zeroBasedIdx+1)); }
        catch (Exception excp) {
            System.out.println("sqlResultT::getInt():"+excp);
            return 0;
        }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public double getDouble(int zeroBasedIdx) {
        try {
            return Double.parseDouble(rs.getString(zeroBasedIdx+1)); }
        catch (Exception excp) {
            System.out.println("sqlResultT::getInt():"+excp);
            return 0.0;
        }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public boolean hasNext() {
        if (rs==null)
            return false;
        try { return rs.next(); }
        catch (Exception excp) { return false; }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public void dump() {
        if (rs==null || meta==null) {
            System.out.println("sqlResultT::dump: rs==null || meta==null");
            return;
        }

        System.out.println("sqlResultT::dump:");
        try {
            //
            // display column data
            //
            int i,colCount = meta.getColumnCount();
            while (rs.next()) {
                for (i=0; i < colCount; i++) {
                	System.out.print(rs.getString(i+1)+",\t");
                }
            	System.out.println("");
            }
        }
        catch (SQLException sqlEx) {
            System.out.println("sqlResultT::dump err:"+sqlEx);
        }
    }
}


