/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.srv;

import java.sql.*;


//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
public class sqlT {
    public		static	String		MYSQL_DRIVER = "com.mysql.jdbc.Driver";
	private	static	boolean	sqlLoaded = false;

	private	srvT		srv;
	private	boolean	connected = false;
	private	Connection  conn = null;
	private	Statement   stmt = null;

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public sqlT(srvT srv) {
    	this.srv = srv;
        try {
            // load JDBC driver
            Class.forName(MYSQL_DRIVER).newInstance();
			sqlLoaded = true;
        }
        catch (Exception excp) {
			sqlLoaded = false;
            //System.out.println("sqlT::ctor:"+excp);
        }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public boolean connect(String sqlHost, String sqlDB,
                           String sqlUser, String sqlPW) {
		if (!sqlLoaded)
			return false;

        String  DBUrl = "jdbc:mysql://" +
                        sqlHost + "/"   +
                        sqlDB   + "?"   +
                        "user=" + sqlUser + "&" +
                        "password="+sqlPW;
        //srv.display("sqlT::connect:"+DBUrl);

        try {
            // get connection to mysql
            conn = DriverManager.getConnection(DBUrl);

            // create a statement for use on this connection
            stmt = conn.createStatement();
			connected = true;
			srv.display("connected to database "+sqlDB+" on host "+sqlHost);
        }
        catch (SQLException sqlEx) {
			connected = false;
            srv.display("sqlT::connect:"+sqlEx);
        }
        return connected;
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public void close() {
		if (!sqlLoaded || !connected)
			return;

        if (stmt != null) {
            try { stmt.close(); }
            catch (SQLException sqlEx) { System.out.println(sqlEx); }
            stmt = null;
        }

        if (conn != null) {
            try { conn.close(); }
            catch (SQLException sqlEx) { System.out.println(sqlEx); }
            conn = null;
        }
		connected = false;
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public sqlResultT query(String sqlStatement) {
        sqlResultT  result = new sqlResultT();

		if (!sqlLoaded || !connected)
			return result;

        try {
            result.rs   = stmt.executeQuery(sqlStatement);
            result.meta = result.rs.getMetaData();
            return result;
        }
        catch (SQLException sqlEx) {
			srv.display("sqlT::query:"+sqlEx);
            return result;
        }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public int update(String sqlStatement) {
		if (!sqlLoaded || !connected)
			return -1;

        try {
            return stmt.executeUpdate(sqlStatement);
        }
        catch (SQLException sqlEx) {
			srv.display("sqlT::update:"+sqlEx);
            return -1;
        }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public int displayHeader(sqlResultT sqlResult) {
		if (!sqlLoaded || !connected)
			return 0;

        int colCount = 0;
        try {
            // get column count
            colCount = sqlResult.getColumnCount();

            // display column names
            for (int i=0; i < colCount; i++) {
               System.out.print(sqlResult.getColumnName(i+1)+"\t");
            }
            //System.out.println("---------------------------------------------");
        }
        catch (Exception e) {}
        return colCount;
    }
}


