/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.ui;

import JAuto.srv.*;
import java.util.*;

public class clientsTblModelT extends tableModelT {
	static final	int	NAME	= 0;
	static final	int	PW		= 1;
	static final	int 	ONLINE	= 2;
	static final   int	COLUMN_CNT = ONLINE+1;
	
	String	headers[] = {	"Name",
							"Password",
							"Online"
						};

	/**
	 * Constructor for clientsTblModelT.
	 */
	public clientsTblModelT() {
		super();
	}

	public int getColumnCount()                 { return COLUMN_CNT; }
	public String getColumnName(int col)        { return headers[col]; }

	/**
	 * 
	 */
	public Object getValueAt(int row, int col) {
		clientT	client = (clientT)rowData.elementAt(row);
		
		switch (col) {
			case NAME:		return client.getName();
			case PW:		return client.getPW();
			case ONLINE:	return client.getConnCnt()+"";
		}
		return "?";
	}

	/**
	 * update a client in the table model
	 * 
	 * @param sensor
	 */
	public void upd(clientT client) {
		if (client == null)
			return;
		
		if (fnd(client.getName()) != null) {
			fireUpd(client.getTblRow());
		}
		else {
			rowData.add(client);
			fireInserted(getRowCount()-1);
			calcRowNumers();
		}
	}
	
	/**
	 * delete a client from the table model
	 * 
	 * @param name
	 */
	public void delete(String name) {
		clientT client = fnd(name);
		
		if (client != null) {
			rowData.remove(client);
			fireDeleted(client.getTblRow());
			calcRowNumers();
		}
	}


	/**
	 * find a client in the table model
	 * 
	 * @param name
	 * 
	 * @return sensorT
	 */
	clientT fnd(String name) {
		Iterator itr = iterator();
		
		while (itr.hasNext()) {
			clientT client = (clientT)itr.next();
			if (name.equals(client.getName()))
				return client;			
		}		
		return null;
	}
	


	/**
	 * recalc row numbers for table display
	 */
	void calcRowNumers() {
		int		row=0;
		Iterator 	itr = iterator();

		while (itr.hasNext()) {
			clientT client = (clientT)itr.next();
			client.setTblRow(row++);
		}
	}

}
