/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.ui;

import JAuto.srv.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;


/**
 * 
 */
public class condEditT extends frameT {
	conditionTblT	condTbl;
	condT 			cond;
	
	JComboBox		cbDev = new JComboBox();
	JComboBox		cbOp = new JComboBox();
	JComboBox		cbVal = new JComboBox();
	JTextField		fldVal = new JTextField(6);
	JLabel			lblEQ = new JLabel("==");
	
	JButton			okButton = new JButton("OK");
	JButton			cancelButton = new JButton("Cancel");

	/**
	 * Constructor for condEditT
	 * 
	 * @param condTbl
	 * @param cond
	 */
	public condEditT(conditionTblT condTbl, condT cond) {
		super("Edit Condition");
	
		this.condTbl = condTbl;
		this.cond = cond;

		cbOp.addItem("==");
		cbOp.addItem("!=");
		cbOp.addItem("<");
		cbOp.addItem("<=");
		cbOp.addItem(">=");
		cbOp.addItem(">");

		cbVal.addItem("ON");
		cbVal.addItem("OFF");

		cbVal.setVisible(false);
		fldVal.setVisible(false);
		lblEQ.setVisible(false);		
		
		deviceT.loadNamesComboBox(cbDev);
		if (cond==null) {
			cbDev.setSelectedIndex(0);
			setFlds();
		}
		else {
			cbDev.setSelectedItem(cond.getDevice());
			deviceT dev = setFlds();
			if (dev instanceof relayT) {
				cbVal.setSelectedIndex( (cond.getVal()==1) ? 0:1);
			}
			else {
				cbOp.setSelectedItem(cond.getOpString());
				fldVal.setText(""+cond.getVal());
			}
		}

		cbDev.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				setFlds();
			}
		});


		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				okButtonAction();
			}
		});

		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cancelButtonAction();
			}
		});
		
		JPanel	pnl = new JPanel();
		pnl.setLayout(new FlowLayout(FlowLayout.CENTER));
		pnl.setBorder(new EmptyBorder(10,30,10,30));		

		pnl.add(cbDev);
		pnl.add(cbOp);
		pnl.add(lblEQ);
		pnl.add(fldVal);		
		pnl.add(cbVal);
		m_contentPane.add(pnl, BorderLayout.CENTER);
		
		pnl = new JPanel();
		pnl.setLayout(new FlowLayout(FlowLayout.RIGHT));
		pnl.add(okButton);
		pnl.add(cancelButton);
		m_contentPane.add(pnl, BorderLayout.SOUTH);
		
		getRootPane().setDefaultButton(okButton);
		pack();
		xcenter();
		setVisible(true);		
	}

	
	/**
	 * handle OK button selection
	 */
	void okButtonAction() {
		if (cbOp.isVisible()) {
			// save a condition for a sensor
			if (cond==null) {
				cond = new condT((String)cbDev.getSelectedItem(),
								(String)cbOp.getSelectedItem(),
								fldVal.getText());
				condTbl.add(cond);								
			}
			else {
				cond.setDevice((String)cbDev.getSelectedItem());
				cond.setOp((String)cbOp.getSelectedItem());
				cond.setVal(fldVal.getText());
				condTbl.upd(cond);
			}			
		}
		else {
			// save a condition for a relay
			if (cond==null) {
				cond = new condT((String)cbDev.getSelectedItem(),
								"==",
								(String)cbVal.getSelectedItem());
				condTbl.add(cond);
			}
			else {
				cond.setDevice((String)cbDev.getSelectedItem());
				cond.setOp((String)cbOp.getSelectedItem());
				cond.setVal((String)cbVal.getSelectedItem());
				condTbl.upd(cond);
			}			
		}
		dispose();
	}


	/**
	 * handle CANCEL button selection
	 */
	void cancelButtonAction() {
		dispose();
	}


	/**
	 * init the fields
	 */
	private deviceT setFlds() {
		String 	name = (String)cbDev.getSelectedItem();
		deviceT	dev = deviceT.fnd(name);

		if (dev instanceof relayT) {
			cbOp.setVisible(false);
			lblEQ.setVisible(true);
			fldVal.setVisible(false);
			cbVal.setVisible(true);
			pack();			
		}
		else {
			cbOp.setVisible(true);
			lblEQ.setVisible(false);
			fldVal.setVisible(true);
			cbVal.setVisible(false);
			pack();			
		}
		return dev;
	}
}
