/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.ui;

import JAuto.srv.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;


public class conditionPnlT extends panelT {
	relayEditT 		relayEdit;
	JButton			addButton = new JButton("Add");
	JButton			edtButton = new JButton("Edit");
	JButton			delButton = new JButton("Delete");	
	conditionTblT	condTbl = new conditionTblT(new conditionTblModelT());
	JScrollPane		listScrollPane	= new JScrollPane(condTbl);
	

	/**
	 * Constructor for conditionPnlT.
	 */
	public conditionPnlT(relayEditT relayEditFrame, LinkedList conditions, String toolTip) {
		super();
		this.relayEdit = relayEditFrame;
		
		//
		// load condition list
		//
		if (conditions != null) {
			Iterator itr = conditions.iterator();
			while (itr.hasNext()) {
				add(new condT((condT)itr.next()));
			}
		}
		
		listScrollPane.setMaximumSize(new Dimension(Short.MAX_VALUE, Short.MAX_VALUE));
		listScrollPane.setPreferredSize(new Dimension(240,120));

		addButton.setAlignmentX(Component.CENTER_ALIGNMENT);
		addButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				buttonAction('A');
			}
		});
		
		edtButton.setAlignmentX(Component.CENTER_ALIGNMENT);
		edtButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				buttonAction('E');
			}
		});
		
		delButton.setAlignmentX(Component.CENTER_ALIGNMENT);
		delButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				buttonAction('D');
			}
		});

		JPanel	pnlZ = new JPanel();
		pnlZ.setLayout(new BoxLayout(pnlZ,BoxLayout.X_AXIS));

		JPanel	pnl = new JPanel();
		pnl.setLayout(new BoxLayout(pnl,BoxLayout.Y_AXIS));
		pnl.setAlignmentY(Component.TOP_ALIGNMENT);		
		pnl.add(addButton);
		pnl.add(Box.createVerticalStrut(4));
		pnl.add(edtButton);
		pnl.add(Box.createVerticalStrut(4));
		pnl.add(delButton);
		pnl.setBorder(new EmptyBorder(6,6,6,6));
		pnlZ.add(pnl);
		
		pnl = new JPanel();
		pnl.setAlignmentY(Component.TOP_ALIGNMENT);
		pnl.add(listScrollPane);
		
		pnlZ.add(pnl);
		
		add(pnlZ, BorderLayout.CENTER);
		
		pnl = new JPanel();
		pnl.setLayout(new FlowLayout(FlowLayout.RIGHT));
		JLabel	lbl = new JLabel(toolTip);
		lbl.setHorizontalAlignment(SwingConstants.CENTER);
		lbl.setAlignmentX(Component.CENTER_ALIGNMENT);
		pnl.add(lbl);
		add(pnl, BorderLayout.SOUTH);		
	}
	
	
	/**
	 * get the iterator for this tbl's data
	 * 
	 * @return Iterator
	 */
	Iterator iterator() {
		return condTbl.iterator();
	}


	/**
	 * handle a button selection
	 * 
	 * @param action
	 */
	void buttonAction(char action) {
		switch (action) {
			case 'A':
				new condEditT(condTbl, null);
				break;
				
			case 'D':
				condTbl.delete(condTbl.getEntry(-1));
				break;
				
			case 'E':
				condT c = condTbl.getEntry(-1);
				if (c != null)
					new condEditT(condTbl, c);
				break;
		}
	}
	

	/**
	 * add a condition to the tbl
	 * @param cond
	 */
	void add(condT cond) {
		condTbl.add(cond);
	}
}
