/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.ui;

import JAuto.srv.*;

import JAuto.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.text.*;

/**
 * edit a controller
 */
public class controllerEditT extends frameT {
	srvT 			srv = srvT.getInstance();
	uiT 			ui = uiT.getInstance();
	
	ioPortT				io;
	JPanel				appPnl = new JPanel();
	JFormattedTextField	fldAddr;
	JComboBox 			cbBoard = new JComboBox();
	JCheckBox			chkEnable = new JCheckBox();
	JButton				okButton = new JButton("OK");
	JButton				cancelButton = new JButton("Cancel");

	/**
	 * Constructor for controllerEditT.
	 * 
	 * @param ttl
	 */
	public controllerEditT(ioPortT io) {
		super("Controller Setup");
		this.io = io;
		
		cbBoard.addItem("B2102");
		cbBoard.addItem("PPORT");
		cbBoard.addItem("B3001");
		cbBoard.setEnabled(false);
		
		MaskFormatter fmt = null;
		try { fmt = new MaskFormatter("0xHHH"); } 
			catch (Exception e) {}
		fldAddr = new JFormattedTextField(fmt);
		fldAddr.setPreferredSize(new Dimension(44,20));	//width,height
		if (io == null) {
			fldAddr.setValue("0x000");
			chkEnable.setSelected(false);
		}
		else {
			cbBoard.setSelectedItem(io.getName().toUpperCase());
			fldAddr.setValue(io.getBaseHexStr());
			chkEnable.setSelected(io.getEnabled());
		}
			
		m_contentPane.add(appPnl, BorderLayout.CENTER);

			
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				okButtonAction();
			}
		});
		getRootPane().setDefaultButton(okButton);

		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cancelButtonAction();
			}
		});

		appPnl.setLayout(new BoxLayout(appPnl,BoxLayout.Y_AXIS));
		appPnl.setBorder(new EmptyBorder(6,6,6,6));
		appPnl.setPreferredSize(new Dimension(300,120));	//width,height

		header(appPnl,new JLabel("Board:"),cbBoard);
		header(appPnl,new JLabel("Address:"),fldAddr);
		header(appPnl,new JLabel("Enabled:"),chkEnable);		
		m_contentPane.add(appPnl, BorderLayout.CENTER);

		JPanel pnl = new JPanel();
		pnl.setLayout(new FlowLayout(FlowLayout.RIGHT));
		pnl.add(okButton);
		pnl.add(cancelButton);
		m_contentPane.add(pnl, BorderLayout.SOUTH);		

		pack();
		xcenter();
		setVisible(true);
	}

	
	/**
	 * @param pnl
	 * @param lbl
	 * @param fld
	 */
	void header(JPanel pnl, JLabel lbl, JComponent fld) {
		lbl.setPreferredSize(new Dimension(90,20));
		lbl.setHorizontalAlignment(SwingConstants.RIGHT);
		lbl.setAlignmentX(Component.RIGHT_ALIGNMENT);
		
		JPanel	p = new JPanel();
		p.setLayout(new FlowLayout(FlowLayout.LEFT));
		p.add(lbl);
		p.add(fld);
		pnl.add(p);
	}


	/**
	 * handle an OK button selection
	 */
	void okButtonAction() {
		if (io != null) {
			int addr = Integer.parseInt(fldAddr.getText().substring(2),16);
			int flg = chkEnable.isSelected() ? 1:0;
			sysMsgT.postMsg(sysMsgT.MSG_EDIT_BOARD, io,	addr, flg);
		}
		dispose();
	}
	

	/**
	 * handle a CANCEL button selection
	 */
	void cancelButtonAction() {
		dispose();
	}

}
