/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.ui;

import JAuto.srv.*;
import java.util.*;


public class controllerTblModelT extends tableModelT {
	static final	int	BOARD	= 0;
	static final	int	ADDR	= 1;
	static final	int 	ENABLED	= 2;
	static final   int	COLUMN_CNT = ENABLED+1;
	
	String	headers[] = {	"Board",
							"Address",
							"Enabled"
						};
	
	/**
	 * Constructor for controllerTblModelT.
	 */
	public controllerTblModelT() {
		super();
	}

	public int getColumnCount()                 { return COLUMN_CNT; }
	public String getColumnName(int col)        { return headers[col]; }

	/**
	 * 
	 */
	public Object getValueAt(int row, int col) {
		ioPortT	io = (ioPortT)rowData.elementAt(row);
		
		switch (col) {
			case BOARD:	return io.getName();
			case ADDR:		return io.getBaseHexStr();
			case ENABLED:	return io.getEnabled() ? "Yes":"No";
		}
		return "?";
	}


	/**
	 * update a controller in the table
	 * 
	 * @param sensor
	 */
	public void upd(ioPortT io) {
		if (io == null)
			return;
		
		if (fnd(io.getName()) != null) {
			fireUpd(io.getTblRow());
		}
		else {
			rowData.add(io);
			fireInserted(getRowCount()-1);
			calcRowNumers();
		}
	}


	/**
	 * find a controller in the table
	 * 
	 * @param name
	 * 
	 * @return ioPortT
	 */
	ioPortT fnd(String name) {
		Iterator itr = iterator();
		
		while (itr.hasNext()) {
			ioPortT io = (ioPortT)itr.next();
			if (name.equals(io.getName()))
				return io;			
		}		
		return null;
	}


	/**
	 * recalc row numbers for tbl display
	 */	
	void calcRowNumers() {
		int		row=0;
		Iterator 	itr = iterator();

		while (itr.hasNext()) {
			ioPortT io = (ioPortT)itr.next();
			io.setTblRow(row++);
		}
	}
}
