/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.ui;

import JAuto.srv.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;


public class relayTblT extends JTable {
	relayTblModelT 	mdl;
	
	/**
	 * 
	 * @param mdl
	 */
	public relayTblT(relayTblModelT mdl) {
		super(mdl);
		this.mdl = mdl;
		
		//setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		JTableHeader myHeader = getTableHeader();
		myHeader.setForeground(new Color(255, 255, 255));
		myHeader.setBackground(new Color(80, 90, 155));
		myHeader.setBorder(BorderFactory.createRaisedBevelBorder());
		
		addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				Point   p = e.getPoint();
				int     row = rowAtPoint(p);

				//getSelectionModel().setSelectionInterval(row,row);
				if (e.getClickCount() == 2) {
					//
					// hdl dbl click
					//
					dblClick(row);
				}
			}
		});
		
		TableColumn  column = null;
		try {
			// board col
			column = getColumnModel().getColumn(relayTblModelT.BOARD);
			column.setCellRenderer(new tblCellRenderT());
			column.setPreferredWidth(50);
			
			// channel col
			column = getColumnModel().getColumn(relayTblModelT.CHANNEL);
			column.setCellRenderer(new tblCellRenderT());
			column.setPreferredWidth(45);

			// type col
			column = getColumnModel().getColumn(relayTblModelT.TYPE);
			column.setCellRenderer(new tblCellRenderT());
			column.setPreferredWidth(50);

			// state col
			column = getColumnModel().getColumn(relayTblModelT.STATE);
			column.setCellRenderer(new tblCellRenderT());
			column.setPreferredWidth(60);
		}
		catch (Exception e) {}
	}


	/**
	 * get the table entry at 'row'
	 * 
	 * @param row
	 * 
	 * @return relayT
	 */
	public relayT getEntry(int row) {
		try {
			if (row < 0)
				row = getSelectedRow();
			else if ( row > getRowCount())
				return null;

			return (relayT)mdl.rowData.elementAt(row);
		}
		catch (Exception excp) {
			return null;
		}
	}
	
	
	/**
	 * handle a double click in the table
	 * 
	 * @param row
	 */
	private void dblClick(int row) {
		relayT relay = getEntry(row);

		if (relay != null) {
			new relayEditT(relay);
		}
	}
	
	
	/**
	 * update a relay in the table
	 * 
	 * @param relay
	 */
	public void upd(relayT relay) {
		mdl.upd(relay);
	}	


	/**
	 * delete a relay from the table
	 * @param name
	 */
	public void delete(String name) {
		mdl.delete(name);
	}
}
