/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package JAuto.ui;

import JAuto.srv.*;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import com.jrefinery.chart.JFreeChart;
import com.jrefinery.chart.ChartPanel;
import com.jrefinery.chart.axis.HorizontalDateAxis;
import com.jrefinery.chart.axis.NumberAxis;
import com.jrefinery.chart.axis.VerticalNumberAxis;
import com.jrefinery.chart.plot.XYPlot;
import com.jrefinery.chart.renderer.XYItemRenderer;
//import com.jrefinery.chart.renderer.StandardXYItemRenderer;
//import com.jrefinery.data.TimeSeries;
import com.jrefinery.data.TimeSeriesCollection;
import com.jrefinery.data.Second;
//import com.jrefinery.data.MovingAverage;


public class sensorChartT extends frameT {
	private	TimeSeriesCollection	dataset;
	private	LinkedList				sensors;
	//private	TimeSeries				movingAvg = null;
	//private	int				 	movingAvgDepth;

	
	public sensorChartT(String frameTTL) {
		super(frameTTL);
		
		dataset = new TimeSeriesCollection();
		sensors = new LinkedList();		
	}
	
	/**
	 * 
	 */
	public void init() {
		HorizontalDateAxis domain = new HorizontalDateAxis("Time");
		VerticalNumberAxis range = new VerticalNumberAxis("Sensor Value");

		XYPlot xyplot = new XYPlot(dataset, domain, range);
		xyplot.setBackgroundPaint(Color.black);
		XYItemRenderer renderer = xyplot.getRenderer();
		/*
		if (renderer instanceof StandardXYItemRenderer) {
			StandardXYItemRenderer rr = (StandardXYItemRenderer) renderer;
			rr.setPlotShapes(true);
			rr.setDefaultShapeFilled(true);
		}
		*/

		renderer.setDefaultStroke(new BasicStroke(2f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL));

		domain.setAutoRange(true);
		domain.setLowerMargin(0.10);
		domain.setUpperMargin(0.10);
		domain.setTickLabelsVisible(true);

		range.setStandardTickUnits(NumberAxis.createIntegerTickUnits());
		range.setAutoRangeIncludesZero(false);

		JFreeChart chart = new JFreeChart(null,JFreeChart.DEFAULT_TITLE_FONT,xyplot,true);

		m_contentPane.add(new ChartPanel(chart), BorderLayout.CENTER);
		
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				stop();
			}
		});

		
		pack();
		setSize(520,300);
		setVisible(true);
	}


	/**
	 * 
	 * @param sensor
	 */
	public sensorChartElementT addSensor(sensorT sensor) {
		sensor.addChart(this);		
		sensorChartElementT element = new sensorChartElementT(sensor);
		sensors.add(element);
		dataset.addSeries(element.getSeries());
		return element;
	}

	/**
	 * 
	 * @param element
	 * @param depth
	 */	
	/*
	public void addMovingAvg(sensorChartElementT element, int depth) {
		movingAvgDepth = depth;
		movingAvg = MovingAverage.createMovingAverage(element.getSeries(),"Average", 
					movingAvgDepth, movingAvgDepth);		
		dataset.addSeries(movingAvg);		
	}
	*/	

	/**
	 * 
	 * @param element
	 * @param depth
	 */
	/*	
	public void updMovingAvg(sensorChartElementT element) {
		if (movingAvg != null)
			dataset.removeSeries(movingAvg);
		//movingAvg = new sensorChartElementT(element.getSeries(), movingAvgDepth);		
		movingAvg = MovingAverage.createMovingAverage(element.getSeries(),"Average", 
					movingAvgDepth, movingAvgDepth);		
		dataset.addSeries(movingAvg);		
	}	
	*/


	/**
	 * 
	 * @param value
	 */
	public void addToSeries(sensorT sensor, int value) {
		sensorChartElementT e = fndElement(sensor);
		if (e != null) {
			e.getSeries().add(new Second(), value);
			/*
			if (movingAvg != null) {
				updMovingAvg(e);
			}
			*/
		}
	}

	/**
	 * 
	 * @param sensor
	 * @return sensorChartElementT
	 */
	private sensorChartElementT fndElement(sensorT sensor) {
		Iterator itr = sensors.iterator();
		
		while (itr.hasNext()) {
			sensorChartElementT e = (sensorChartElementT)itr.next();
			if (e.getSensor() == sensor)
				return e;
		}
		
		return null;
	}

	/**
	 * 
	 */
	private void stop() {
		Iterator itr = sensors.iterator();
		
		while (itr.hasNext()) {
			sensorChartElementT e = (sensorChartElementT)itr.next();
			sensorT sensor = e.getSensor();
			
			if (sensor != null)
				sensor.delChart(this);
		}
	}
}
