/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.ui;

import JAuto.srv.*;
import JAuto.util.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;


public class sensorEditT extends frameT {
	srvT 			srv = srvT.getInstance();
	uiT 			ui = uiT.getInstance();
	
	sensorT			sensor;

	JPanel			appPnl = new JPanel();
	JTextField		fldName;
	JComboBox 		cbBoard = new JComboBox();
	JComboBox 		cbChannel = new JComboBox();
	JButton			okButton = new JButton("OK");
	JButton			cancelButton = new JButton("Cancel");

	/**
	 * Constructor for sensorEditT.
	 * @param ttl
	 */
	public sensorEditT(sensorT sensor) {
		super("Sensor Setup");
		
		this.sensor = sensor;
		
		cbBoard.addItem("B3001");

		for (int i=1; i<= 16; i++)
			cbChannel.addItem(""+i);
		
		fldName = new JTextField(10);
		
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				okButtonAction();
			}
		});
		getRootPane().setDefaultButton(okButton);

		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cancelButtonAction();
			}
		});
		
		if (sensor != null) {
			fldName.setText(sensor.getName());
			cbBoard.setSelectedItem(sensor.getBoardName());
			cbChannel.setSelectedItem(Integer.toString(sensor.getChannel()));
		}
		
		
		appPnl.setLayout(new BoxLayout(appPnl,BoxLayout.Y_AXIS));
		appPnl.setBorder(new EmptyBorder(6,6,6,6));
		appPnl.setPreferredSize(new Dimension(300,120));	//width,height
		
		header(appPnl,new JLabel("Device Name:"),fldName);
		header(appPnl,new JLabel("Board:"),cbBoard);
		header(appPnl,new JLabel("Channel:"),cbChannel);
		m_contentPane.add(appPnl, BorderLayout.CENTER);

		JPanel pnl = new JPanel();
		pnl.setLayout(new FlowLayout(FlowLayout.RIGHT));
		pnl.add(okButton);
		pnl.add(cancelButton);
		m_contentPane.add(pnl, BorderLayout.SOUTH);		
		

		pack();
		xcenter();
		setVisible(true);
	}


	/**
	 * handle OK button selection
	 */
	void okButtonAction() {
		sensorT s = new sensorT(fldName.getText());
		
		s.setName(fldName.getText());
		
		if (cbBoard.getSelectedIndex() == 0)
			s.setBoard(srv.b3001);
			
		s.setChannel(cbChannel.getSelectedIndex()+1);
		
		sysMsgT.postMsg(sysMsgT.MSG_EDIT_SENSOR, s, sensor);
		dispose();
	}
	

	/**
	 * handle CANCEL button selection
	 */
	void cancelButtonAction() {
		dispose();
	}

	
	/**
	 * 
	 * @param pnl
	 * @param txt
	 * @param fld
	 */
	void header(JPanel pnl, JLabel lbl, JComponent fld) {
		lbl.setPreferredSize(new Dimension(90,20));
		lbl.setHorizontalAlignment(SwingConstants.RIGHT);
		lbl.setAlignmentX(Component.RIGHT_ALIGNMENT);
		
		JPanel	p = new JPanel();
		p.setLayout(new FlowLayout(FlowLayout.LEFT));
		p.add(lbl);
		p.add(fld);
		pnl.add(p);
	}
}
