/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.ui;

import JAuto.srv.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

public class sqlPnlT extends panelT {
	srvT		srv;
	boolean	updated = false;	
	JPanel		appPnl = new JPanel();
	JTextField	fldHost	= new JTextField(16);
	JTextField	fldDB	= new JTextField(16);
	JTextField	fldUser = new JTextField(16);
	JTextField	fldPW	= new JTextField(16);
	JCheckBox	cbDetail = new JCheckBox();
	JButton		updButton = new JButton("Update");
	
	public sqlPnlT() {
		super();
		init();
	}
	
	public void init() {
		srv = srvT.getInstance();
		
		fldHost.setText(srv.ini.sqlHost);
		fldDB.setText(srv.ini.sqlDB);
		fldUser.setText(srv.ini.sqlUser);
		fldPW.setText(srv.ini.sqlPW);
		cbDetail.setSelected(srv.ini.sqlDetail);

		chgDocumentListener chg = new chgDocumentListener(this);
		fldHost.getDocument().addDocumentListener(chg);
		fldDB.getDocument().addDocumentListener(chg);
		fldUser.getDocument().addDocumentListener(chg);
		fldPW.getDocument().addDocumentListener(chg);
		cbDetail.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				hdlUpdate();
			}
		});

		
		appPnl.setLayout(new BoxLayout(appPnl,BoxLayout.Y_AXIS));
		appPnl.setBorder(new EmptyBorder(20,6,30,6));

		header(new JLabel("SQL Host:"),fldHost);
		header(new JLabel("Database:"),fldDB);
		header(new JLabel("User:"),fldUser);
		header(new JLabel("Password:"),fldPW);
		header(new JLabel("Detail:"),cbDetail);		
		
		
		appPnl.add(Box.createVerticalGlue());
		
		add(appPnl, BorderLayout.CENTER);
		
		JPanel pnl = new JPanel();
		pnl.setLayout(new FlowLayout(FlowLayout.RIGHT));
		pnl.add(updButton);
		add(pnl, BorderLayout.SOUTH);
		
		updButton.setEnabled(false);	
		updButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				updButtonAction();
			}
		});
	}

	/**
	 * 
	 */
	void hdlUpdate() {
		updated = true;
		updButton.setEnabled(true);
	}
	

	/**
	 * handle upd button selection
	 */
	void updButtonAction() {
		if (updated == false)
			return;
		updButton.setEnabled(false);
			
		srv.ini.sqlHost	= fldHost.getText();
		srv.ini.sqlDB	= fldDB.getText();
		srv.ini.sqlUser = fldUser.getText();
		srv.ini.sqlPW	= fldPW.getText();
		srv.ini.sqlDetail= cbDetail.isSelected();
		
		srv.ini.saveProp();
		
		/*
		 * drop connection to sql server
		 */
		srv.sql.close();

		/*
		 * re-connect to sql database (if avail)
		 */
		srv.sql.connect(srv.ini.sqlHost,
						srv.ini.sqlDB,
						srv.ini.sqlUser,
						srv.ini.sqlPW);
	}
	

	/**
	 * 
	 * @param pnl
	 * @param txt
	 * @param fld
	 */
	void header(JLabel lbl, JComponent fld) {
		lbl.setPreferredSize(new Dimension(90,20));
		lbl.setHorizontalAlignment(SwingConstants.RIGHT);
		lbl.setAlignmentX(Component.RIGHT_ALIGNMENT);
		
		JPanel	p = new JPanel();
		p.setLayout(new FlowLayout(FlowLayout.LEFT));
		p.add(lbl);
		p.add(fld);
		
		appPnl.add(p);
	}

}



class chgDocumentListener implements DocumentListener {
	sqlPnlT pnl;
	
	chgDocumentListener(sqlPnlT pnl) {
		this.pnl = pnl;
	}
	
	public void insertUpdate(DocumentEvent e) {
		pnl.hdlUpdate();
	}
	public void removeUpdate(DocumentEvent e) {
		pnl.hdlUpdate();
	}
	public void changedUpdate(DocumentEvent e) {
		pnl.hdlUpdate();
	}
}    