/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package JAuto.ui;

import java.awt.event.*;
import java.net.*;
import java.util.*;
import javax.swing.*;

/**
 * 
 */
//class toolBarItemT extends JButton {
class toolBarItemT {
	public static   final int    SEPARATOR	= 0;
	public static   final int    ICON		= 1;
	public static   final int    TEXT		= 2;
	public static   final int    COMPONENT	= 3;

	boolean	enabled;
	boolean	dspFlg;
	int		typ;       
	int		id;        
	char		toolBarId; 
	toolBarT	tb;
	JComponent	comp;

	toolBarItemT(toolBarT tb, char tbId) {
		this.enabled = true;
		this.dspFlg  = true;
		this.typ     = SEPARATOR;
		this.id      = -1;
		this.tb      = tb;
		this.toolBarId = tbId;
		this.comp = new JButton();
	}

	toolBarItemT(toolBarT tb, char tbId, int id, ImageIcon icon) {
		//super(icon);
		this.enabled = true;
		this.dspFlg  = true;
		this.typ     = ICON;
		this.id      = id;
		this.tb      = tb;
		this.toolBarId = tbId;
		this.comp = new JButton(icon);
	}
	toolBarItemT(toolBarT tb, char tbId, int id, String txt) {
		//super(txt);
		this.enabled = true;
		this.dspFlg  = true;
		this.typ     = TEXT;
		this.id      = id;
		this.tb      = tb;
		this.toolBarId = tbId;
		this.comp = new JButton(txt);
	}
	toolBarItemT(toolBarT tb, char tbId, int id, JComponent comp) {
		//super(comp);
		this.enabled = true;
		this.dspFlg  = true;
		this.typ     = ICON;
		this.id      = id;
		this.tb      = tb;
		this.toolBarId = tbId;
		this.comp = comp;
	}

}

/**
 * 
 */
public class toolBarT extends JToolBar {
    frameT          msgFrame;
    char            curToolBarID;
    ArrayList       items;      //toolBarItemT list

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public toolBarT(frameT msgFrame) {
        super();

        this.msgFrame  = msgFrame;

        items = new ArrayList();      //toolBarItemT list

        setFloatable(false);
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public toolBarItemT addIcon(char tbId, int id, String action, String pth) {
        URL url = getClass().getResource(pth);
        if (url == null)
            return null;

        ImageIcon icon = new ImageIcon(url);
        if (icon == null)
            return null;

        toolBarItemT itm = new toolBarItemT(this,tbId,id,icon);

		JButton btn = (JButton)itm.comp;
        btn.setToolTipText(action);
		btn.setActionCommand(action);
		btn.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                msgFrame.toolBarAction(e);
            }
        });

        items.add(itm);
        return itm;
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public toolBarItemT addButton(char tbId, int id, String action, String txt) {
        toolBarItemT itm = new toolBarItemT(this,tbId,id,txt);

		JButton btn = (JButton)itm.comp;
        btn.setToolTipText(txt);
		btn.setActionCommand(action);
		btn.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                msgFrame.toolBarAction(e);
            }
        });

        items.add(itm);
        return itm;
    }

	//------------------------------------------------------------------------
	//------------------------------------------------------------------------
	public toolBarItemT addComponent(char tbId, int id, JComponent comp) {
		toolBarItemT itm = new toolBarItemT(this,tbId,id,comp);
		items.add(itm);
		return itm;
	}


    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public toolBarItemT addSep(char tbId) {
        toolBarItemT itm = new toolBarItemT(this,tbId);
        items.add(itm);
        return itm;
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public void clear() {
        removeAll();
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public toolBarItemT fnd(int id) {
        Iterator     itr = items.iterator();
        toolBarItemT itm;

        while (itr.hasNext()) {
            itm = (toolBarItemT)itr.next();
            if (itm.id == id)
                return itm;
        }
        return null;
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public void enable(int id, boolean state) {
        toolBarItemT itm = fnd(id);
        if (itm != null) {
            itm.enabled = state;
            itm.comp.setEnabled(state);
        }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public void display(int id, boolean state) {
        toolBarItemT itm = fnd(id);
        if (itm != null) {
            itm.dspFlg = state;
        }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public void setToolTip(int id, String txt) {
        toolBarItemT itm = fnd(id);
        if (itm != null) {
            itm.comp.setToolTipText(txt);
        }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public void setActionCommand(int id, String txt) {
        toolBarItemT itm = fnd(id);
        if (itm != null) {
        	if (itm.comp instanceof JButton) {
				JButton btn = (JButton)itm.comp;
            	btn.setActionCommand(txt);
        	}
        }
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public void setActive(char id) {
        curToolBarID = id;
        upd();
    }

    //------------------------------------------------------------------------
    //------------------------------------------------------------------------
    public void upd() {
        toolBarItemT itm;
        Iterator     itr = items.iterator();

        clear();

        while (itr.hasNext()) {
            itm = (toolBarItemT)itr.next();
            if (itm.toolBarId == curToolBarID) {
                if (itm.dspFlg) {
                    if (itm.typ == toolBarItemT.SEPARATOR)
                        addSeparator();
                    else
                        add(itm.comp);
                    
                    /*    
					switch (itm.typ) {
						case toolBarItemT.SEPARATOR:
							addSeparator();
							break;
						case toolBarItemT.ICON:
						case toolBarItemT.TEXT:
						case toolBarItemT.COMPONENT:
							add(itm.comp);
							break;
					}
					*/
                }
            }
        }
        repaint();
    }

}
