/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.ui;

import JAuto.srv.*;

import JAuto.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class uiT extends frameT {
    static final   int lExit		= 0;
    static final   int lAdd		= 1;
	static final   int lEdit		= 2;
	static final   int lDel		= 3;
	static final   int lRestore	= 4;	
	static final   int lUp		= 5;
	static final   int lDn		= 6;
	static final   int lChart		= 7;
	static final   int lClrSQL	= 8;
	
    static final   int TAB_RELAYS		= 0;
	static final   int TAB_SENSORS	= 1;
	static final   int TAB_BOARDS		= 2;
	static final   int TAB_CLIENTS	= 3;
	static final   int TAB_SQL		= 4;
	static final   int TAB_LOG		= 5;
    
    static	uiT			instance = null;

	srvT				srv = srvT.getInstance();
	
    JLabel              appStat = new JLabel();
    JPanel              appCenter = new JPanel();
    JPanel              appSouth = new JPanel();

    DefaultListModel    logListModel = new DefaultListModel();
    JList               logList = new JList(logListModel);
    JScrollPane         logScrollPane = new JScrollPane(logList);
	JPanel              logTab = new JPanel();
    JTabbedPane         tabbedPane = new JTabbedPane();
    toolBarT            tb = new toolBarT(this);

	relayTblModelT		relayMdl = new relayTblModelT();
	relayTblT 			relayTbl = new relayTblT(relayMdl);
	JScrollPane         relayScrollPane = new JScrollPane(relayTbl);
	panelT              relayTab = new panelT();
	
	sensorTblModelT		sensorMdl = new sensorTblModelT();
	sensorTblT 			sensorTbl = new sensorTblT(sensorMdl);
	JScrollPane         sensorScrollPane = new JScrollPane(sensorTbl);
	panelT              sensorTab = new panelT();

	controllerTblModelT	controllerMdl = new controllerTblModelT();
	controllerTblT 		controllerTbl = new controllerTblT(controllerMdl);
	JScrollPane         controllerScrollPane = new JScrollPane(controllerTbl);
	JPanel              controllerTab = new panelT();

	clientsTblModelT	clientsMdl = new clientsTblModelT();
	clientsTblT 		clientsTbl = new clientsTblT(clientsMdl);
	JScrollPane         clientsScrollPane = new JScrollPane(clientsTbl);
	JPanel              clientsTab = new panelT();
	
	sqlPnlT				sqlTab = new sqlPnlT();
	
	
	int                 tabFocus = TAB_RELAYS;
    Color               lightyellow = new Color(255, 255, 208);

	public uiT(String ttl) {
		super(ttl);
		instance = this;
        init();
	}
	
	/**
	 * get the instance of this 'ui'
	 * 
	 * @return uiT
	 */
	public static uiT getInstance() {
		return instance;
	}


    /**
     * init the ui
     */
    private void init() {
		//---------------------------------------------------------------------
		// relays tab
		//---------------------------------------------------------------------
		relayTab.add(relayScrollPane, BorderLayout.CENTER);
		relayTab.addComponentListener(new ComponentAdapter() {
			public void componentShown(ComponentEvent e) {
				tabShown(TAB_RELAYS);
			}
			public void componentHidden(ComponentEvent e) {
				tabHidden(TAB_RELAYS);
			}
		});		
		tabbedPane.add(relayTab,"Relays");

		//---------------------------------------------------------------------
		// sensors tab
		//---------------------------------------------------------------------
		sensorTab.add(sensorScrollPane, BorderLayout.CENTER);
		sensorTab.addComponentListener(new ComponentAdapter() {
			public void componentShown(ComponentEvent e) {
				tabShown(TAB_SENSORS);
			}
			public void componentHidden(ComponentEvent e) {
				tabHidden(TAB_SENSORS);
			}
		});		
		tabbedPane.add(sensorTab,"Sensors");

		//---------------------------------------------------------------------
		// controllers tab
		//---------------------------------------------------------------------
		controllerTab.add(controllerScrollPane, BorderLayout.CENTER);
		controllerTab.addComponentListener(new ComponentAdapter() {
			public void componentShown(ComponentEvent e) {
				tabShown(TAB_BOARDS);
			}
			public void componentHidden(ComponentEvent e) {
				tabHidden(TAB_BOARDS);
			}
		});		
		tabbedPane.add(controllerTab,"Controllers");


		//---------------------------------------------------------------------
		// clients tab
		//---------------------------------------------------------------------
		if (srv.appType == srvT.SERVER) {
			clientsTab.add(clientsScrollPane, BorderLayout.CENTER);
			clientsTab.addComponentListener(new ComponentAdapter() {
				public void componentShown(ComponentEvent e) {
					tabShown(TAB_CLIENTS);
				}
				public void componentHidden(ComponentEvent e) {
					tabHidden(TAB_CLIENTS);
				}
			});		
			tabbedPane.add(clientsTab,"Clients");
		}

		//---------------------------------------------------------------------
		// sql tab
		//---------------------------------------------------------------------
		if (srv.appType == srvT.SERVER) {
			sqlTab.addComponentListener(new ComponentAdapter() {
				public void componentShown(ComponentEvent e) {
					tabShown(TAB_SQL);
				}
				public void componentHidden(ComponentEvent e) {
					tabHidden(TAB_SQL);
				}
			});		
			tabbedPane.add(sqlTab,"SQL");
		}

		//---------------------------------------------------------------------
		// log tab
		//---------------------------------------------------------------------
		logList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		logList.setBackground(lightyellow);
		logTab.setLayout(new BorderLayout());
		logTab.add(logScrollPane, BorderLayout.CENTER);
		logTab.addComponentListener(new ComponentAdapter() {
			public void componentShown(ComponentEvent e) {
				tabShown(TAB_LOG);
			}
			public void componentHidden(ComponentEvent e) {
				tabHidden(TAB_LOG);
			}
		});		
		tabbedPane.add(logTab,"Messages");

		tabShown(TAB_RELAYS);
		

        appCenter.setLayout(new BorderLayout());
        appCenter.setBorder(BorderFactory.createEtchedBorder());
        appCenter.add(tabbedPane, BorderLayout.CENTER);

        appSouth.setLayout(new FlowLayout(FlowLayout.LEFT));
        appSouth.add(appStat);

        m_contentPane.add(tb, BorderLayout.NORTH);
        m_contentPane.add(appCenter, BorderLayout.CENTER);
        m_contentPane.add(appSouth, BorderLayout.SOUTH);

        setupToolBar();

        this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
				srv.shutdown();
            }
        });

        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        setSize(520,320);
        xcenter();
        setVisible(true);
    }


    /**
     * init toolbar
     */
    public void setupToolBar() {
        tb.addIcon('1',lExit,	"Exit",		"/JAuto/icons/stop2.gif");
        tb.addSep('1');
        tb.addIcon('1',lAdd,	"Add",		"/JAuto/icons/add.gif");
		tb.addIcon('1',lEdit,	"Edit",		"/JAuto/icons/edit.gif");
		tb.addIcon('1',lDel,	"Delete",	"/JAuto/icons/cut.gif");
		tb.addSep('1');
		tb.addIcon('1',lRestore,"Restore relay state",	"/JAuto/icons/toggle.gif");
		tb.addIcon('1',lUp,		"Force relay on",	"/JAuto/icons/up.gif");
		tb.addIcon('1',lDn,		"Force relay off",	"/JAuto/icons/down.gif");
		tb.addSep('1');
		tb.addIcon('1',lChart,	"Chart Sensor",	"/JAuto/icons/chart.gif");
		tb.addIcon('1',lClrSQL,	"Clear SQl Averages",	"/JAuto/icons/redo.gif");		
		

		tb.setActionCommand(lRestore, "forceRelayStop");
		tb.setActionCommand(lUp, "forceRelayOn");
		tb.setActionCommand(lDn, "forceRelayOff");
		tb.setActionCommand(lChart, "chartSensor");
		tb.setActionCommand(lClrSQL, "clrSQL");

        tb.setActive('1');
    }


    /**
     * handle a toolbar action
     * 
     * @see frameT#toolBarAction(ActionEvent)
     */
    public void toolBarAction(ActionEvent evt) {
		relayT relay; 
        String cmd = evt.getActionCommand();

        if (cmd.equals("Exit")) {
			srv.shutdown();
        } 
        
        /*
         * relay commands
         */
        else if (cmd.equals("addRelay")) {
			new relayEditT(null);
			
		} 
		else if (cmd.equals("editRelay")) {
			if (relayTbl.getEntry(-1) != null)
				new relayEditT(relayTbl.getEntry(-1));
			else 
				JOptionPane.showMessageDialog(this,"Select a relay to edit you stoner!");
        }        
		else if (cmd.equals("forceRelayOn")) {
			relay = relayTbl.getEntry(-1);
			if (relay == null)
				JOptionPane.showMessageDialog(this,"Select a relay you stoner!");
			else
				sysMsgT.postMsg(sysMsgT.MSG_OVERRIDE, relay, 1);
		}				
		else if (cmd.equals("forceRelayOff")) {
			relay = relayTbl.getEntry(-1);
			if (relay == null)
				JOptionPane.showMessageDialog(this,"Select a relay you stoner!");
			else
				sysMsgT.postMsg(sysMsgT.MSG_OVERRIDE, relay, 0);
		}
		else if (cmd.equals("forceRelayStop")) {
			relay = relayTbl.getEntry(-1);
			if (relay == null)
				JOptionPane.showMessageDialog(this,"Select a relay you stoner!");
			else
				sysMsgT.postMsg(sysMsgT.MSG_OVERRIDE, relay, -1);
		}
		else if (cmd.equals("chartRelay")) {
			chartRelay();
		}
        else if (cmd.equals("delRelay")) {
        	relayT curRelay = relayTbl.getEntry(-1) ;
			if (curRelay == null) 
				JOptionPane.showMessageDialog(this,"Select a relay to delete you stoner!");
			else {
				int result = JOptionPane.showConfirmDialog(this,
							 "Do you wish to delete the relay "+curRelay.getName()+"?",
							 "Delete Selected Relay",
							 JOptionPane.YES_NO_OPTION);
				if (result == JOptionPane.YES_OPTION) {
					//relayTbl.delete(curRelay.getName());
					sysMsgT.postMsg(sysMsgT.MSG_DEL_RELAY, curRelay.getName());
				}				
			}			
		}

		/*
		 * sensor commands
		 */
		else if (cmd.equals("addSensor")) {
			new sensorEditT(null);			
		} else if (cmd.equals("editSensor")) {
			if (sensorTbl.getEntry(-1) != null)
				new sensorEditT(sensorTbl.getEntry(-1));
			else 
				JOptionPane.showMessageDialog(this,"Select a sensor to edit you stoner!");
		}		
		else if (cmd.equals("chartSensor")) {
			chartSensor();
		}
		else if (cmd.equals("clrSQL")) {
			sensorT curSensor = sensorTbl.getEntry(-1) ;
			if (curSensor == null) 
				JOptionPane.showMessageDialog(this,"Select a sensor to clear you stoner!");
			else {
				int result = JOptionPane.showConfirmDialog(this,
							 "Do you wish to clear the sql averages for the sensor "+curSensor.getName()+"?",
							 "Clear Selected Sensor",
							 JOptionPane.YES_NO_OPTION);
				if (result == JOptionPane.YES_OPTION) {
					sysMsgT.postMsg(sysMsgT.MSG_CLR_SENSOR, curSensor);
				}				
			}			
		}
		else if (cmd.equals("delSensor")) {
			sensorT curSensor = sensorTbl.getEntry(-1) ;
			if (curSensor == null) 
				JOptionPane.showMessageDialog(this,"Select a sensor to delete you stoner!");
			else {
				int result = JOptionPane.showConfirmDialog(this,
							 "Do you wish to delete the sensor "+curSensor.getName()+"?",
							 "Delete Selected Sensor",
							 JOptionPane.YES_NO_OPTION);
				if (result == JOptionPane.YES_OPTION) {
					sysMsgT.postMsg(sysMsgT.MSG_DEL_SENSOR, curSensor.getName());
				}				
			}			
		}
		/*
		 * controller commands
		 */		 
		else if (cmd.equals("editController")) {
			if (controllerTbl.getEntry(-1) != null) {
				new controllerEditT(controllerTbl.getEntry(-1));
			}
			else 
				JOptionPane.showMessageDialog(this,"Select a controller to edit you stoner!");
		}		
         
        else {
            logMsg("toolBarAction:"+cmd);
        }
    }

	/**
	 * 
	 */
	private void chartRelay() {
		int[] rowIndices = relayTbl.getSelectedRows();
		
		if (rowIndices.length <= 0) {
			JOptionPane.showMessageDialog(this,"Select a relay to chart you stoner!");
			return;
		}		
		
		relayT			relay;
		relayChartT	chart;
		if (rowIndices.length == 1) {
			relay = relayTbl.getEntry(rowIndices[0]);
			chart = new relayChartT("Chart for: "+relay.getName());
			chart.addRelay(relay);
			//element = chart.addSensor(sensor);
			//chart.addMovingAvg(element,60*5);
		}
		else {
			chart = new relayChartT("JAuto Chart");
			for (int i=0; i<rowIndices.length; i++) {
				relay = relayTbl.getEntry(rowIndices[i]) ;
				chart.addRelay(relay);
			}
		}	
		chart.init();
	}

	/**
	 * 
	 */
	private void chartSensor() {
		int[] rowIndices = sensorTbl.getSelectedRows();
		
		if (rowIndices.length <= 0) {
			JOptionPane.showMessageDialog(this,"Select a sensor to chart you stoner!");
			return;
		}		
		
		sensorT			sensor;
		sensorChartT	chart;
		//sensorChartElementT element;
		if (rowIndices.length == 1) {
			sensor = sensorTbl.getEntry(rowIndices[0]);
			chart = new sensorChartT("Chart for: "+sensor.getName());
			chart.addSensor(sensor);
			//element = chart.addSensor(sensor);
			//chart.addMovingAvg(element,60*5);
		}
		else {
			chart = new sensorChartT("JAuto Chart");
			for (int i=0; i<rowIndices.length; i++) {
				sensor = sensorTbl.getEntry(rowIndices[i]) ;
				chart.addSensor(sensor);
			}
		}		
		
		chart.init();
	}


	/**
	 * set toolbar buttons depending on what tab is shown
	 * 
	 * @param tabId
	 */
	private void tabShown(int tabId) {
		boolean iconState1 = true;
		boolean iconState2 = true;
		boolean iconState3 = true;
		boolean iconState4 = false;
		boolean iconState5 = false;
		
		tabFocus = tabId;
		switch (tabId) {
			case TAB_RELAYS:
				tb.setToolTip(lAdd,"Add relay");
				tb.setToolTip(lEdit,"Edit relay");
				tb.setToolTip(lDel,"Delete relay");			
				tb.setActionCommand(lAdd, "addRelay");
				tb.setActionCommand(lEdit,"editRelay");
				tb.setActionCommand(lDel, "delRelay");
				tb.setActionCommand(lChart, "chartRelay");
				iconState4 = true;
				//iconState5 = true;				
				iconState5 = false;
				break;
			case TAB_SENSORS:
				tb.setToolTip(lAdd,"Add sensor");
				tb.setToolTip(lEdit,"Edit sensor");
				tb.setToolTip(lDel,"Delete sensor");
				tb.setActionCommand(lAdd, "addSensor");
				tb.setActionCommand(lEdit,"editSensor");
				tb.setActionCommand(lDel, "delSensor");
				tb.setActionCommand(lChart, "chartSensor");
				iconState5 = true;
				break;
			case TAB_BOARDS:
				iconState1 = false;
				iconState2 = true;
				iconState3 = false;
				tb.setToolTip(lEdit,"Edit controller");
				tb.setActionCommand(lEdit,"editController");
				break;
			case TAB_CLIENTS:
				tb.setToolTip(lAdd,"Add client");
				tb.setToolTip(lEdit,"Edit client");
				tb.setToolTip(lDel,"Delete client");
				tb.setActionCommand(lAdd, "addClient");
				tb.setActionCommand(lEdit,"editClient");
				tb.setActionCommand(lDel, "delClient");				
				break;
			case TAB_SQL:
				iconState1 = false;
				iconState2 = false;
				iconState3 = false;
				break;
			case TAB_LOG:
				iconState1 = false;
				iconState2 = false;
				iconState3 = false;
				break;
		}
		tb.display(lAdd,iconState1);
		tb.display(lEdit,iconState2);
		tb.display(lDel,iconState3);
		tb.display(lRestore,iconState4);
		tb.display(lUp,iconState4);
		tb.display(lDn,iconState4);
		tb.display(lChart,iconState5);
		tb.display(lClrSQL,iconState5);		
		tb.upd();
		//pack();
	}

	
	/**
	 * 
	 * @param tabId
	 */
	private void tabHidden(int tabId) {
	}


	/**
	 * update a controller display
	 * 
	 * @param io
	 */
	public void updClients(clientT client) {
		SwingUtilities.invokeLater(new clientsUpdRunnableT(this,client));
	}
	

	/**
	 * update a controller display
	 * 
	 * @param io
	 */
	public void updController(ioPortT io) {
		controllerTbl.upd(io);
	}

	
	/**
	 * update a relay display
	 * 
	 * @param relay
	 */	
	public void updRelay(relayT relay) {
		SwingUtilities.invokeLater(new relayUpdRunnableT(this,relay));
	}
	public void delRelay(String name) {
		SwingUtilities.invokeLater(new relayUpdRunnableT(this,name));
	}
	
	/**
	 * update a sensor display
	 * 
	 * @param sensor
	 */
	public void updSensor(sensorT sensor) {
		SwingUtilities.invokeLater(new sensorUpdRunnableT(this,sensor));
	}
	public void delSensor(String name) {
		SwingUtilities.invokeLater(new sensorUpdRunnableT(this,name));
	}

	/**
	 * display a msg to the msg tab of the app
	 * 
	 * @param msg
	 */
    public void logMsg(String msg) {
        SwingUtilities.invokeLater(new logMsgRunnableT(this,msg));
    }

	/**
	 * 
	 * @param msg
	 */
    void _logMsg(String msg) {
        logListModel.addElement(msg);
        logList.ensureIndexIsVisible(logListModel.size()-1);
    }
}


/**
 * 
 */
class logMsgRunnableT implements Runnable {
	uiT     ui;
	String  txt;

	logMsgRunnableT(uiT ui, String txt) {
		this.ui = ui;
		this.txt = txt;
	}

	public void run() {
		ui._logMsg(txt);
	}
};


/**
 * 
 */
class updRunnableT implements Runnable {
	uiT     ui;
	char	action;
	String	name;
	
	public void run() {
	}
}

/**
 * 
 */
class relayUpdRunnableT extends updRunnableT {
	relayT	relay;

	relayUpdRunnableT(uiT ui, relayT relay) {
		this.ui = ui;
		this.relay = relay;
		this.action = 'u';
	}

	relayUpdRunnableT(uiT ui, String name) {
		this.ui = ui;
		this.name = name;
		this.action = 'd';
	}

	public void run() {
		if (action == 'u')
			ui.relayTbl.upd(relay);
		else if (action == 'd')
			ui.relayTbl.delete(name);
	}
};

/**
 * 
 */
class sensorUpdRunnableT extends updRunnableT {
	sensorT	sensor;

	sensorUpdRunnableT(uiT ui, sensorT sensor) {
		this.ui = ui;
		this.sensor = sensor;
		this.action = 'u';
	}

	sensorUpdRunnableT(uiT ui, String name) {
		this.ui = ui;
		this.name = name;
		this.action = 'd';

	}
	public void run() {
		if (action == 'u')
			ui.sensorTbl.upd(sensor);
		else if (action == 'd')
			ui.sensorTbl.delete(name);
	}
};

/**
 * 
 */
class clientsUpdRunnableT implements Runnable {
	uiT     ui;
	clientT	client;

	clientsUpdRunnableT(uiT ui, clientT client) {
		this.ui = ui;
		this.client = client;
	}

	public void run() {
		ui.clientsTbl.upd(client);
	}
};
