/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.util;

import java.util.*;
import JAuto.srv.*;
import JAuto.util.*;

public class msgT {
	public int		cmd;
	public String	device;
	public String	board;
	public int		channel;
	public String	slaveOf;
	public int		state;
	public int		int1;
	public int		int2;
	public String	data1;
	public String	data2;
	public String	data3;
	public String	data4;
	
	public msgT() {
		reset();
	}
	
	public msgT(int cmd, String device) {
		reset();
		this.cmd = cmd;
		this.device = device;
	}

	public msgT(msgT msg) {
		this.cmd		= msg.cmd;
		this.channel	= msg.channel;
		this.state		= msg.state;
		this.device	= new String(msg.device);
		this.board		= new String(msg.board);
		this.slaveOf	= new String(msg.slaveOf);
		
		this.int1		= msg.int1;
		this.int2		= msg.int2;
		this.data1		= new String(msg.data1);
		this.data2		= new String(msg.data2);		
		this.data3		= new String(msg.data3);
		this.data4		= new String(msg.data4);
	}
	
	public void reset() {
		cmd = 0;
		channel = 0;
		state = 0;
		device = "";
		board = "";
		slaveOf = "";
		
		int1 = 0;
		int2 = 0;
		data1 = "";
		data2 = "";
		data3 = "";
		data4 = "";
	}
	
	/**
	 * copy a relayT to a msgT
	 * 
	 * @param relay
	 */
	public msgT bldRelayMsg(relayT relay) {
		reset();
		cmd = sysMsgT.MSG_EDIT_RELAY;
		device = relay.getName();
		board  = relay.getBoardName();
		channel = relay.getChannel();
		
		state = relay.getState() == true ? 1:0;

		int1 = relay.getRelayTyp();
		int2 = relay.isOverRide() ? 1:0;
		
		if (relay.getRelayTyp() == relayT.SLAVE)
			slaveOf = relay.getSlaveDevice().getName();
		else {
			if (relay.getRelayTyp() != relayT.COND) {
				//
				// put time data in 'data1'
				// 					
				Calendar cal = relay.getOnCalendar();
				data1 =	cal.get(Calendar.HOUR_OF_DAY) + ":" +
							cal.get(Calendar.MINUTE) + ":" +
							cal.get(Calendar.SECOND) + ":";
			
				cal = relay.getOffCalendar();
				data1 =	data1 +
							cal.get(Calendar.HOUR_OF_DAY) + ":" +
							cal.get(Calendar.MINUTE) + ":" +
							cal.get(Calendar.SECOND) + ":";
			}
			
			//
			// put "on condition" data in 'data2'
			//		
			Iterator itr = relay.getOnConditions().iterator();		
			while (itr.hasNext()) {
				condT	cond = (condT)itr.next();
				data2 = data2 +
							cond.getDevice()   + ":" +
							'"' + cond.getOpString() + '"' + ":" +
							cond.getVal()      + "|";	
			}

			//
			// put "off condition" data in 'data3'
			//		
			itr = relay.getOffConditions().iterator();		
			while (itr.hasNext()) {
				condT	cond = (condT)itr.next();
				data3 = data3 +
							cond.getDevice()   + ":" +
							'"' + cond.getOpString() + '"' + ":" +
							cond.getVal()      + "|";	
			}
		}
		
		//dump();
		//sock.sendMsg(msg);
		return this;		
	}

	/**
	 * copy a sensorT to a msgT
	 * 
	 * @param sensor
	 */
	public msgT bldSensorMsg(sensorT sensor) {

		reset();
		
		cmd = sysMsgT.MSG_EDIT_SENSOR;
		device = sensor.getName();
		board  = sensor.getBoardName();
		channel = sensor.getChannel();
		
		int1 = sensor.getSensorDat();

		return this;
	}

	
	public String toString() {
		return "cmd="+cmd+
				" dev="+device+
				" brd="+board+
				" chnl="+channel+
				" state="+state+
				" slv="+slaveOf+
				" i1="+int1+
				" i2="+int2+"\n"+
				" d1="+data1+"\n"+
				" d2="+data2+"\n"+
				" d3="+data3+"\n"+
				" d4="+data4;
	}
	
	public void dump() {
		System.out.println(toString());
	}
}
