/**
 *  Copyright (c) 2002-2003, ngc7579
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
package JAuto.util;

import java.net.*;
import java.io.*;


public class sockT {
	public static   final char   TOK_CMD			= 'Z';
	public static   final char   TOK_ETX			= 'X';
	public static   final char   TOK_INT			= 'I';
	public static   final char   TOK_DATA		= 'D';
	
	public static   final char   TOK_DEVICE		= 'V';
	public static   final char   TOK_CHANNEL		= 'C';
	public static   final char   TOK_STATE		= 'S';
	public static   final char   TOK_BOARD		= 'B';
	public static   final char   TOK_SLAVEOF		= 'L';
	
	
	public static   final String STR_CMD			= TOK_CMD+"=";
	public static   final String STR_ETX			= TOK_ETX+";";
	
	public static   final String STR_INT			= TOK_INT+"=";
	public static   final String STR_INT1			= TOK_INT+"1=";
	public static   final String STR_INT2			= TOK_INT+"2=";

	public static   final String STR_DATA			= TOK_DATA+"=";
	public static   final String STR_DATA1		= TOK_DATA+"1=";
	public static   final String STR_DATA2		= TOK_DATA+"2=";
	public static   final String STR_DATA3		= TOK_DATA+"3=";
	public static   final String STR_DATA4		= TOK_DATA+"4=";

	public static   final String STR_DEVICE		= TOK_DEVICE+"=";
	public static   final String STR_CHANNEL		= TOK_CHANNEL+"=";
	public static   final String STR_STATE		= TOK_STATE+"=";
	public static   final String STR_BOARD		= TOK_BOARD+"=";
	public static   final String STR_SLAVEOF		= TOK_SLAVEOF+"=";

    int				m_dspSendMsg;
    FileWriter          m_captureFileWriter;
    Socket              socket = null;
    DataInputStream     socketIn;
    DataOutputStream    socketOut;

    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    public sockT() {
        socket    = null;
        socketIn  = null;
        socketOut = null;
        m_dspSendMsg = 0;
        m_captureFileWriter = null;
    }

    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    public sockT(Socket s) {
        socket    = s;
        socketIn  = null;
        socketOut = null;
        m_dspSendMsg = 0;
        m_captureFileWriter = null;

        bldIO();
    }

    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    public boolean isConnected() {
        return (socket != null);
    }

    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    public void setCaptureState(boolean state) {
        try {
            if (m_captureFileWriter != null) {
                m_captureFileWriter.close();
                m_captureFileWriter = null;
            }
        } catch (Exception excp) {
            excp.printStackTrace();
            m_captureFileWriter = null;
            return;
        }

        if (state == true) {
            try {
                m_captureFileWriter = new FileWriter("./sockT.trap",true);
            } catch (Exception excp) {
                excp.printStackTrace();
                m_captureFileWriter = null;
                return;
            }
        }
    }

    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    public void addCaptureTxt(String txt) {
        try {
            if (m_captureFileWriter != null) {
                m_captureFileWriter.write(txt+"\n");
            }
        } catch (Exception excp) {
            excp.printStackTrace();
        }
    }

    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    public void setDspSendMsg(int state) {
        m_dspSendMsg = state;
    }

    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    public InetAddress getInetAddress() {
        return socket.getInetAddress();
    }

    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    public int connect(String url, int port) {
        try {
            socket = new Socket(url,port);
            return bldIO();
        }
        catch(Exception e) {
            //System.out.println(e);
            return -1;
        }
    }

    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    private int bldIO() {
        try {
            // get input stream for 'socketIn'
            InputStream     iraw = socket.getInputStream();
            socketIn = new DataInputStream(iraw);

            // get output stream for 'socketOut'
            OutputStream    oraw = socket.getOutputStream();
            socketOut = new DataOutputStream(oraw);
            return 0;
        }
        catch(Exception e) {
            //System.out.println(e);
            return -1;
        }
    }

    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    public int close() {
        try {
            if (socket != null) {
                if (socketOut != null)
                    socketOut.flush();
                socket.close();
                socket = null;
                socketIn  = null;
                socketOut = null;
            }
            return 0;
        }
        catch(Exception e) {
            socket    = null;
            socketIn  = null;
            socketOut = null;
            //System.out.println("sockT::close:"+e);
            return -911;
        }
    }

	//-----------------------------------------------------------------------
	//-----------------------------------------------------------------------
	public int sendMsg(msgT msg) {
		String  buf;

		//msg.dump();
		try {
			buf = STR_CMD 	  + msg.cmd + ";" +
				  STR_STATE   + msg.state + ";" +
				  STR_CHANNEL + msg.channel + ";" +
				  STR_INT1	  + msg.int1 + ";" +
				  STR_INT2	  + msg.int2 + ";";
				  
			if (msg.device.length() > 0)
				buf = buf + STR_DEVICE  + msg.device + ";";
			
			if (msg.board.length() > 0)
				buf = buf + STR_BOARD + msg.board + ";";
			
			if (msg.slaveOf.length() > 0)
				buf = buf + STR_SLAVEOF + msg.slaveOf + ";";

			if (msg.data1.length() > 0)
				buf = buf + STR_DATA1 + msg.data1 + ";";
			
			if (msg.data2.length() > 0)
				buf = buf + STR_DATA2 + msg.data2 + ";";
				
			if (msg.data3.length() > 0)
				buf = buf + STR_DATA3 + msg.data3 + ";";
				  
			if (msg.data4.length() > 0)
				buf = buf + STR_DATA4 + msg.data4 + ";";

			buf += STR_ETX;
			
			synchronized (socketOut) {
				socketOut.writeBytes(buf);
				socketOut.flush();
			}
			return 0;
		}
		catch(Exception e) {
			System.out.println("sockT::sendMsg(msg):"+e);
			return -1;
		}
	}

	//-----------------------------------------------------------------------
	//-----------------------------------------------------------------------
	public int sendMsg(int cmd) {
		String  buf;

		try {
			buf = STR_CMD + cmd + ";" + STR_ETX;
			synchronized (socketOut) {
				socketOut.writeBytes(buf);
				socketOut.flush();
			}
			return 0;
		}
		catch(Exception e) {
			//System.out.println("sockT::sendMsg:"+e);
			return -1;
		}
	}

	//-----------------------------------------------------------------------
	//-----------------------------------------------------------------------
	public int sendMsg(int cmd, String txt) {
		try {
			synchronized (socketOut) {
				socketOut.writeBytes(STR_CMD + cmd + ";" + txt + STR_ETX);
				socketOut.flush();
			}

			if (m_dspSendMsg == 1) {
				String o = STR_CMD + cmd + ";" + txt + STR_ETX;
				System.out.println(o);
			}
			return 0;
		}
		catch(Exception e) {
			close();
			return -1;
		}
	}

    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    public int sendBuf(String buf) {
        try {
            synchronized (socketOut) {
                socketOut.writeBytes(buf);
                socketOut.flush();
            }
            return 0;
        }
        catch(Exception e) {
            return -1;
        }
    }


    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    public String readTok() {
        boolean         inQuote = false;
        char            c;
        StringBuffer    sbuf = new StringBuffer();

        try {
            while (true) {
                c = (char)socketIn.readUnsignedByte();
                if (c == '\"') {
                    if (inQuote == true) {
                        // done with quoted field
                        inQuote = false;
                        continue;
                    }
                    else {
                        // start quoted field
                        inQuote = true;
                        continue;
                    }
                }
                else {
                    if (inQuote == false) {
                        if (c == ';' || c == '=') {
                            break;
                        }
                    }
                }

                // put char in buffer
                sbuf.append(c);
                if (c == '\n')
                    break;
            }
            return new String(sbuf);
        }
        catch(Exception e) {
            close();
            return null;
        }

    }

    //-----------------------------------------------------------------------
    //-----------------------------------------------------------------------
    public int readMsg(msgT msg) {
        try {
            String  key;
            String  tok;
            char    c0,c1;

            // clear all fields in 'msg'
            msg.reset();

            //
            // looking for 'Z;'
            //
            while (true) {
                if (null == (key=readTok())) 
                    return -1;

                if (key.length() < 1) 
                    return -1;
                    
                if (key.charAt(0) == TOK_CMD)        //Z;
                    break;
            }

            // got cmd verb; get the cmd number now...
            if (null == (tok=readTok())) {
                return -1;
            }
            msg.cmd = Integer.parseInt(tok);


            //
            // get rest of msg (stop when etx)
            //
            while (true) {
                if (null == (key=readTok())) 
                    return -1;

                c0 = key.charAt(0);
                if ((c0 == TOK_ETX) || (c0 == '\n')) {   //X;
                    if (m_captureFileWriter != null) {
                        m_captureFileWriter.write(msg.toString());
                    }
                    return 0;
                }

                // we know that each of the following verbs need
                // a parm, so get it now
                if (null == (tok=readTok()))
                    return -1;

                //
                // find out what the cmd was and proc token accodingly
                //
                switch (c0) {
	                case TOK_CHANNEL:
    	                //C=number from 1 to 16;
                    	msg.channel = Integer.parseInt(tok);
	                    break;

					case TOK_STATE:
						//S=number 0 or 1;
						msg.state = Integer.parseInt(tok);
						break;

					case TOK_DEVICE:
						//V=string device name;
						msg.device = new String(tok);
						break;

					case TOK_BOARD:
						//B=string board name;
						msg.board = new String(tok);
						break;

					case TOK_SLAVEOF:
						//L=string slave of name;
						msg.slaveOf = new String(tok);
						break;

					case TOK_INT:
						//Ix=...
						c1 = key.charAt(1);
						switch (c1) {
						case '1':
							msg.int1 = Integer.parseInt(tok);
							break;
						case '2':
							msg.int2 = Integer.parseInt(tok);
							break;
						}
						break;

					case TOK_DATA:
						//Dx=...
						c1 = key.charAt(1);
						switch (c1) {
						case '1':
							msg.data1 = new String(tok);
							break;
						case '2':
							msg.data2 = new String(tok);
							break;
						case '3':
							msg.data3 = new String(tok);
							break;
						case '4':
							msg.data4 = new String(tok);
							break;
						}
						break;

    	            default:
        	            System.out.println("sockT::readMsg(), unknown cmd:"+key);
            	        break;
                }   //switch(c0)
            }
            //we'll never get here...
        }
        catch(Exception e) {
            System.out.println("sockT::readMsg:"+e);
            e.printStackTrace();
            close();
            return -1;
        }
    }

}

